# Copyright (c) 2021 Project CHIP Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

name:
    Window Covering [TC-WNCV-4.2] GoToTiltPercentage command Long-Run
    Verification [DUT as Server]

PICS:
    - WNCV.S

config:
    nodeId: 0x12344321
    cluster: "Window Covering"
    endpoint: 1
    fullMotionDuration:
        type: int16u
        defaultValue: 6000

tests:
    - label: "Step 0: Wait for the commissioned device to be retrieved"
      cluster: "DelayCommands"
      command: "WaitForCommissionee"
      arguments:
          values:
              - name: "nodeId"
                value: nodeId

    ### Step 1x -> Initialize the Covering position before any testing
    ### MANDATORY Init Commands
    - label:
          "Step 1a: TH sends DownOrClose command to preposition the DUT in the
          opposite direction"
      command: "DownOrClose"
      PICS: WNCV.S.C01.Rsp

    ### Step 5x -> Verify the DUT has moved
    ### DUT moves toward its DownOrClose position
    - label: "Step 1b: TH waits for x seconds movement(s) on the DUT"
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: fullMotionDuration

    ### Depends on the FeatureMap -> Check CurrentPosition attributes
    - label:
          "Step 1c: If (PA & TL) TH reads CurrentPositionTiltPercent100ths
          attribute from DUT"
      command: "readAttribute"
      attribute: "CurrentPositionTiltPercent100ths"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.A000f
      response:
          constraints:
              notValue: 0

    ######## GoToTiltPercentage Long-Run 30 percent #######
    ### Step 2x ->  Check GoToTiltPercentage 30% Long-Run effects
    - label:
          "Step 2a: TH sends GoToTiltPercentage command with 30 percent to DUT"
      command: "GoToTiltPercentage"
      PICS: WNCV.S.F01 && WNCV.S.C08.Rsp
      arguments:
          values:
              - name: "TiltPercent100thsValue"
                value: 3000

    ### Depends on a sleep/wait command how to do this with a real device for CI keep at 100ms
    - label: "Step 2b: TH waits for 100-1000 ms"
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 100

    ### Mandatory Depends on the FeatureMap
    - label:
          "Step 2c: If (PA & TL) TH reads TargetPositionTiltPercent100ths
          attribute from DUT"
      command: "readAttribute"
      attribute: "TargetPositionTiltPercent100ths"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.A000c
      response:
          value: 3000

    ### Step 3x ->  Verify the DUT has reached its 30%
    ### DUT moves toward its 30% position
    - label: "Step 3a: TH waits for PIXIT.WNCV.FULLMOTION on the DUT"
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: fullMotionDuration

    ### Check for END OF MOVEMENTs
    - label: "Step 3b: TH checks OperationalStatus attribute from DUT"
      command: "readAttribute"
      attribute: "OperationalStatus"
      PICS: WNCV.S.A000a
      response:
          value: 0

    ### Mandatory Depends on the FeatureMap
    - label:
          "Step 3c: If (PA & TL) TH reads CurrentPositionTiltPercent100ths
          attribute from DUT"
      command: "readAttribute"
      attribute: "CurrentPositionTiltPercent100ths"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.A000f
      response:
          value: 3000

    ### Optional Depends on the FeatureMap
    - label:
          "Step 3d: If (PA & TL) TH reads CurrentPositionTiltPercentage optional
          attribute from DUT"
      command: "readAttribute"
      attribute: "CurrentPositionTiltPercentage"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.A0009
      response:
          value: 30

    ######## GoToTiltPercentage Long-Run for 60.2 percent #######
    ### Step 4x ->  Check GoToTiltPercentage 60.20% Long-Run effects
    - label:
          "Step 4a: TH sends GoToTiltPercentage command with 60.05 percent to
          DUT"
      command: "GoToTiltPercentage"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.C08.Rsp
      arguments:
          values:
              - name: "TiltPercent100thsValue"
                value: 6005

    ### Depends on a sleep/wait command how to do this with a real device for CI keep at 100ms
    - label: "Step 4b: TH waits for 100-1000 ms"
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 100

    ### Mandatory Depends on the FeatureMap
    - label:
          "Step 4c: If (PA & TL) TH reads TargetPositionTiltPercent100ths
          attribute from DUT"
      command: "readAttribute"
      attribute: "TargetPositionTiltPercent100ths"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.A000c
      response:
          value: 6005

    ### Step 5x ->  Verify the DUT has reached its 60.2%
    ### DUT moves toward its 60.2% position
    - label: "Step 5a: TH waits for PIXIT.WNCV.FULLMOTION on the DUT"
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: fullMotionDuration

    ### Check for END OF MOVEMENTs
    - label: "Step 5b: TH reads OperationalStatus attribute from DUT"
      command: "readAttribute"
      attribute: "OperationalStatus"
      PICS: WNCV.S.A000a
      response:
          value: 0

    ### Mandatory Depends on the FeatureMap
    - label:
          "Step 5c: If (PA & TL) TH reads CurrentPositionTiltPercent100ths
          attribute from DUT"
      command: "readAttribute"
      attribute: "CurrentPositionTiltPercent100ths"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.A000f
      response:
          value: 6005

    ### Optional Depends on the FeatureMap
    - label:
          "Step 5d: If (PA & TL) TH reads CurrentPositionTiltPercentage optional
          attribute from DUT"
      PICS: WNCV.S.F01 && WNCV.S.F04 && WNCV.S.A0009
      command: "readAttribute"
      attribute: "CurrentPositionTiltPercentage"
      response:
          value: 60
